//+------------------------------------------------------------------+
//|                                                       BTrATR.mq4 |
//|                                 Copyright  2009.06.08, SwingMan |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009.06.08, SwingMan"
#property link      ""

#property indicator_separate_window

#property indicator_buffers 1
#property indicator_color1 DeepSkyBlue

//---- external parameters ------------------------------------------
extern int  iPeriod=21;
//-------------------------------------------------------------------

int iShift = 1;

//---- buffers
double myATR[], highs[], lows[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorDigits(Digits);
   IndicatorBuffers(3);
   SetIndexBuffer(0,myATR); SetIndexStyle(0,DRAW_LINE); SetIndexLabel(0,"bt_ATR");
   SetIndexBuffer(1,highs); 
   SetIndexBuffer(2,lows); 
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   
   for (int i=limit; i>=0; i--)
   {
      highs[i]  = iMA(Symbol(),Period(),iPeriod,iShift,MODE_SMA,PRICE_HIGH,i);
      lows[i]   = iMA(Symbol(),Period(),iPeriod,iShift,MODE_SMA,PRICE_LOW,i); 
      myATR[i]  = highs[i] - lows[i];
   }
//----
   
//----
   return(0);
}
//+------------------------------------------------------------------+